<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (19)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="functions">Functions</h1>
    <p>
      Quite often we need to perform a similar action in many places of the
      script.
    </p>
    <p>
      For example, we need to show a nice-looking message when a visitor logs
      in, logs out and maybe somewhere else.
    </p>
    <p>
      Functions are the main “building blocks” of the program. They allow the
      code to be called many times without repetition.
    </p>
    <p>
      We’ve already seen examples of built-in functions, like
      <code>alert(message)</code>, <code>prompt(message, default)</code> and
      <code>confirm(question)</code>. But we can create functions of our own as
      well.
    </p>
    <h2 id="function-declaration">Function Declaration</h2>
    <p>To create a function we can use a <em>function declaration</em>.</p>
    <p>It looks like this:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="kw">function</span> <span class="at">showMessage</span>() <span class="op">{</span></a>
<a class="sourceLine" id="cb1-2" title="2">  <span class="at">alert</span>(<span class="st">&quot;Hello everyone!&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      The <code>function</code> keyword goes first, then goes the
      <em>name of the function</em>, then a list of <em>parameters</em> between
      the parentheses (comma-separated, empty in the example above) and finally
      the code of the function, also named “the function body”, between curly
      braces.
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">function</span> <span class="at">name</span>(parameters) <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  ...<span class="va">body</span>...</a>
<a class="sourceLine" id="cb2-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Our new function can be called by its name: <code>showMessage()</code>.
    </p>
    <p>For instance:</p>
    <p>```js run function showMessage() { alert( ‘Hello everyone!’ ); }</p>
    <p><em>!</em> showMessage(); showMessage(); <em>/!</em> ```</p>
    <p>
      The call <code>showMessage()</code> executes the code of the function.
      Here we will see the message two times.
    </p>
    <p>
      This example clearly demonstrates one of the main purposes of functions:
      to avoid code duplication.
    </p>
    <p>
      If we ever need to change the message or the way it is shown, it’s enough
      to modify the code in one place: the function which outputs it.
    </p>
    <h2 id="local-variables">Local variables</h2>
    <p>
      A variable declared inside a function is only visible inside that
      function.
    </p>
    <p>For example:</p>
    <p>
      ```js run function showMessage() { <em>!</em> let message = “Hello, I’m
      JavaScript!”; // local variable <em>/!</em>
    </p>
    <p>alert( message ); }</p>
    <p>showMessage(); // Hello, I’m JavaScript!</p>
    <p>
      alert( message ); // &lt;– Error! The variable is local to the function
      ```
    </p>
    <h2 id="outer-variables">Outer variables</h2>
    <p>A function can access an outer variable as well, for example:</p>
    <p>```js run no-beautify let <em>!</em>userName<em>/!</em> = ‘John’;</p>
    <p>
      function showMessage() { let message = ‘Hello,’ +
      <em>!</em>userName<em>/!</em>; alert(message); }
    </p>
    <p>showMessage(); // Hello, John ```</p>
    <p>
      The function has full access to the outer variable. It can modify it as
      well.
    </p>
    <p>For instance:</p>
    <p>```js run let <em>!</em>userName<em>/!</em> = ‘John’;</p>
    <p>
      function showMessage() { <em>!</em>userName<em>/!</em> = “Bob”; // (1)
      changed the outer variable
    </p>
    <p>
      let message = ‘Hello,’ + <em>!</em>userName<em>/!</em>; alert(message); }
    </p>
    <p>
      alert( userName ); // <em>!</em>John<em>/!</em> before the function call
    </p>
    <p>showMessage();</p>
    <p>
      alert( userName ); // <em>!</em>Bob<em>/!</em>, the value was modified by
      the function ```
    </p>
    <p>The outer variable is only used if there’s no local one.</p>
    <p>
      If a same-named variable is declared inside the function then it
      <em>shadows</em> the outer one. For instance, in the code below the
      function uses the local <code>userName</code>. The outer one is ignored:
    </p>
    <p>```js run let userName = ‘John’;</p>
    <p>
      function showMessage() { <em>!</em> let userName = “Bob”; // declare a
      local variable <em>/!</em>
    </p>
    <p>
      let message = ‘Hello,’ + userName; // <em>!</em>Bob<em>/!</em>
      alert(message); }
    </p>
    <p>// the function will create and use its own userName showMessage();</p>
    <p>
      alert( userName ); // <em>!</em>John<em>/!</em>, unchanged, the function
      did not access the outer variable ```
    </p>
    <p>
      ``<code
        >smart header="Global variables" Variables declared outside of any
        function, such as the outer</code
      >userName` in the code above, are called <em>global</em>.
    </p>
    <p>
      Global variables are visible from any function (unless shadowed by
      locals).
    </p>
    <p>
      It’s a good practice to minimize the use of global variables. Modern code
      has few or no globals. Most variables reside in their functions. Sometimes
      though, they can be useful to store project-level data. ```
    </p>
    <h2 id="parameters">Parameters</h2>
    <p>
      We can pass arbitrary data to functions using parameters (also called
      <em>function arguments</em>) .
    </p>
    <p>
      In the example below, the function has two parameters:
      <code>from</code> and <code>text</code>.
    </p>
    <p>
      ```js run function showMessage(<em>!</em>from, text<em>/!</em>) { //
      arguments: from, text alert(from + ‘:’ + text); }
    </p>
    <p>
      <em>!</em> showMessage(‘Ann’, ‘Hello!’); // Ann: Hello! (*)
      showMessage(‘Ann’, “What’s up?”); // Ann: What’s up? (**) <em>/!</em> ```
    </p>
    <p>
      When the function is called in lines <code>(*)</code> and
      <code>(**)</code>, the given values are copied to local variables
      <code>from</code> and <code>text</code>. Then the function uses them.
    </p>
    <p>
      Here’s one more example: we have a variable <code>from</code> and pass it
      to the function. Please note: the function changes <code>from</code>, but
      the change is not seen outside, because a function always gets a copy of
      the value:
    </p>
    <p>```js run function showMessage(from, text) {</p>
    <p>
      <em>!</em> from = ‘<em>’ + from + ’</em>’; // make “from” look nicer
      <em>/!</em>
    </p>
    <p>alert( from + ‘:’ + text ); }</p>
    <p>let from = “Ann”;</p>
    <p>showMessage(from, “Hello”); // <em>Ann</em>: Hello</p>
    <p>
      // the value of “from” is the same, the function modified a local copy
      alert( from ); // Ann ```
    </p>
    <h2 id="default-values">Default values</h2>
    <p>
      If a parameter is not provided, then its value becomes
      <code>undefined</code>.
    </p>
    <p>
      For instance, the aforementioned function
      <code>showMessage(from, text)</code> can be called with a single argument:
    </p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="at">showMessage</span>(<span class="st">&quot;Ann&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      That’s not an error. Such a call would output
      <code>"*Ann*: undefined"</code>. There’s no <code>text</code>, so it’s
      assumed that <code>text === undefined</code>.
    </p>
    <p>
      If we want to use a “default” <code>text</code> in this case, then we can
      specify it after <code>=</code>:
    </p>
    <p>
      ```js run function showMessage(from, <em>!</em>text = “no text
      given”<em>/!</em>) { alert( from + “:” + text ); }
    </p>
    <p>showMessage(“Ann”); // Ann: no text given ```</p>
    <p>
      Now if the <code>text</code> parameter is not passed, it will get the
      value <code>"no text given"</code>
    </p>
    <p>
      Here <code>"no text given"</code> is a string, but it can be a more
      complex expression, which is only evaluated and assigned if the parameter
      is missing. So, this is also possible:
    </p>
    <p>
      <code
        >js run function showMessage(from, text = anotherFunction()) { //
        anotherFunction() only executed if no text given // its result becomes
        the value of text }</code
      >
    </p>
    <p>
      ```smart header=“Evaluation of default parameters” In JavaScript, a
      default parameter is evaluated every time the function is called without
      the respective parameter.
    </p>
    <p>
      In the example above, <code>anotherFunction()</code> is called every time
      <code>showMessage()</code> is called without the
      <code>text</code> parameter. ```
    </p>
    <h3 id="alternative-default-parameters">Alternative default parameters</h3>
    <p>
      Sometimes it makes sense to set default values for parameters not in the
      function declaration, but at a later stage, during its execution.
    </p>
    <p>
      To check for an omitted parameter, we can compare it with
      <code>undefined</code>:
    </p>
    <p>
      ```js run function showMessage(text) { <em>!</em> if (text === undefined)
      { text = ‘empty message’; } <em>/!</em>
    </p>
    <p>alert(text); }</p>
    <p>showMessage(); // empty message ```</p>
    <p>…Or we could use the <code>||</code> operator:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="co">// if text parameter is omitted or &quot;&quot; is passed, set it to &#39;empty&#39;</span></a>
<a class="sourceLine" id="cb4-2" title="2"><span class="kw">function</span> <span class="at">showMessage</span>(text) <span class="op">{</span></a>
<a class="sourceLine" id="cb4-3" title="3">  text <span class="op">=</span> text <span class="op">||</span> <span class="st">&#39;empty&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb4-4" title="4">  ...</a>
<a class="sourceLine" id="cb4-5" title="5"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      Modern JavaScript engines support the
      <a href="info:nullish-coalescing-operator">nullish coalescing operator</a>
      <code>??</code>, it’s better when falsy values, such as <code>0</code>,
      are considered regular:
    </p>
    <p>
      ```js run // if there’s no “count” parameter, show “unknown” function
      showCount(count) { alert(count ?? “unknown”); }
    </p>
    <p>
      showCount(0); // 0 showCount(null); // unknown showCount(); // unknown ```
    </p>
    <h2 id="returning-a-value">Returning a value</h2>
    <p>
      A function can return a value back into the calling code as the result.
    </p>
    <p>The simplest example would be a function that sums two values:</p>
    <p>
      ```js run no-beautify function sum(a, b) { <em>!</em>return<em>/!</em> a +
      b; }
    </p>
    <p>let result = sum(1, 2); alert( result ); // 3 ```</p>
    <p>
      The directive <code>return</code> can be in any place of the function.
      When the execution reaches it, the function stops, and the value is
      returned to the calling code (assigned to <code>result</code> above).
    </p>
    <p>
      There may be many occurrences of <code>return</code> in a single function.
      For instance:
    </p>
    <p>
      ```js run function checkAge(age) { if (age &gt;= 18) { <em>!</em> return
      true; <em>/!</em> } else { <em>!</em> return confirm(‘Do you have
      permission from your parents?’); <em>/!</em> } }
    </p>
    <p>let age = prompt(‘How old are you?’, 18);</p>
    <p>
      if ( checkAge(age) ) { alert( ‘Access granted’ ); } else { alert( ‘Access
      denied’ ); } ```
    </p>
    <p>
      It is possible to use <code>return</code> without a value. That causes the
      function to exit immediately.
    </p>
    <p>For example:</p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="kw">function</span> <span class="at">showMovie</span>(age) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="cf">if</span> ( <span class="op">!</span><span class="at">checkAge</span>(age) ) <span class="op">{</span></a>
<a class="sourceLine" id="cb5-3" title="3"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb5-4" title="4">    <span class="cf">return</span><span class="op">;</span></a>
<a class="sourceLine" id="cb5-5" title="5"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb5-6" title="6"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb5-7" title="7"></a>
<a class="sourceLine" id="cb5-8" title="8"><span class="ss">  alert</span><span class="sc">(</span><span class="ss"> &quot;Showing you the movie&quot; </span><span class="sc">)</span><span class="ss">; // </span><span class="sc">(*)</span></a>
<a class="sourceLine" id="cb5-9" title="9"><span class="ss">  // ...</span></a>
<a class="sourceLine" id="cb5-10" title="10"><span class="ss">}</span></a></code></pre>
    </div>
    <p>
      In the code above, if <code>checkAge(age)</code> returns
      <code>false</code>, then <code>showMovie</code> won’t proceed to the
      <code>alert</code>.
    </p>
    <p>
      ```<code>smart header="A function with an empty</code>return<code
        >or without it returns</code
      >undefined<code
        >" If a function does not return a value, it is the same as if it
        returns</code
      >undefined`:
    </p>
    <p>```js run function doNothing() { /* empty */ }</p>
    <p>alert(doNothing() === undefined); // true ```</p>
    <p>
      An empty <code>return</code> is also the same as
      <code>return undefined</code>:
    </p>
    <p>```js run function doNothing() { return; }</p>
    <p>alert(doNothing() === undefined); // true</p>
    <pre><code></code></pre>
    <p>
      ```<code>warn header="Never add a newline between</code>return<code
        >and the value" For a long expression in</code
      >return`, it might be tempting to put it on a separate line, like this:
    </p>
    <div class="sourceCode" id="cb7">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb7-1" title="1"><span class="cf">return</span></a>
<a class="sourceLine" id="cb7-2" title="2"> (some <span class="op">+</span> long <span class="op">+</span> expression <span class="op">+</span> or <span class="op">+</span> whatever <span class="op">*</span> <span class="at">f</span>(a) <span class="op">+</span> <span class="at">f</span>(b))</a></code></pre>
    </div>
    <p>
      That doesn’t work, because JavaScript assumes a semicolon after
      <code>return</code>. That’ll work the same as:
    </p>
    <div class="sourceCode" id="cb8">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb8-1" title="1"><span class="cf">return</span><span class="op">*!*;*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb8-2" title="2"><span class="ss"> </span><span class="sc">(</span><span class="ss">some </span><span class="sc">+</span><span class="ss"> long </span><span class="sc">+</span><span class="ss"> expression </span><span class="sc">+</span><span class="ss"> or </span><span class="sc">+</span><span class="ss"> whatever </span><span class="sc">*</span><span class="ss"> f</span><span class="sc">(</span><span class="ss">a</span><span class="sc">)</span><span class="ss"> </span><span class="sc">+</span><span class="ss"> f</span><span class="sc">(</span><span class="ss">b</span><span class="sc">))</span></a></code></pre>
    </div>
    <p>So, it effectively becomes an empty return.</p>
    <p>
      If we want the returned expression to wrap across multiple lines, we
      should start it at the same line as <code>return</code>. Or at least put
      the opening parentheses there as follows:
    </p>
    <div class="sourceCode" id="cb9">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb9-1" title="1"><span class="cf">return</span> (</a>
<a class="sourceLine" id="cb9-2" title="2">  some <span class="op">+</span> long <span class="op">+</span> expression</a>
<a class="sourceLine" id="cb9-3" title="3">  <span class="op">+</span> or <span class="op">+</span></a>
<a class="sourceLine" id="cb9-4" title="4">  whatever <span class="op">*</span> <span class="at">f</span>(a) <span class="op">+</span> <span class="at">f</span>(b)</a>
<a class="sourceLine" id="cb9-5" title="5">  )</a></code></pre>
    </div>
    <p>And it will work just as we expect it to. `````</p>
    <h2 id="naming-a-function-function-naming">
      Naming a function [#function-naming]
    </h2>
    <p>
      Functions are actions. So their name is usually a verb. It should be
      brief, as accurate as possible and describe what the function does, so
      that someone reading the code gets an indication of what the function
      does.
    </p>
    <p>
      It is a widespread practice to start a function with a verbal prefix which
      vaguely describes the action. There must be an agreement within the team
      on the meaning of the prefixes.
    </p>
    <p>
      For instance, functions that start with <code>"show"</code> usually show
      something.
    </p>
    <p>Function starting with…</p>
    <ul>
      <li><code>"get…"</code> – return a value,</li>
      <li><code>"calc…"</code> – calculate something,</li>
      <li><code>"create…"</code> – create something,</li>
      <li>
        <code>"check…"</code> – check something and return a boolean, etc.
      </li>
    </ul>
    <p>Examples of such names:</p>
    <p>
      <code
        >js no-beautify showMessage(..) // shows a message getAge(..) // returns
        the age (gets it somehow) calcSum(..) // calculates a sum and returns
        the result createForm(..) // creates a form (and usually returns it)
        checkPermission(..) // checks a permission, returns true/false</code
      >
    </p>
    <p>
      With prefixes in place, a glance at a function name gives an understanding
      what kind of work it does and what kind of value it returns.
    </p>
    <p>
      ```smart header=“One function – one action” A function should do exactly
      what is suggested by its name, no more.
    </p>
    <p>
      Two independent actions usually deserve two functions, even if they are
      usually called together (in that case we can make a 3rd function that
      calls those two).
    </p>
    <p>A few examples of breaking this rule:</p>
    <ul>
      <li>
        <code>getAge</code> – would be bad if it shows an
        <code>alert</code> with the age (should only get).
      </li>
      <li>
        <code>createForm</code> – would be bad if it modifies the document,
        adding a form to it (should only create it and return).
      </li>
      <li>
        <code>checkPermission</code> – would be bad if it displays the
        <code>access granted/denied</code> message (should only perform the
        check and return the result).
      </li>
    </ul>
    <p>
      These examples assume common meanings of prefixes. You and your team are
      free to agree on other meanings, but usually they’re not much different.
      In any case, you should have a firm understanding of what a prefix means,
      what a prefixed function can and cannot do. All same-prefixed functions
      should obey the rules. And the team should share the knowledge. ```
    </p>
    <p>
      ```smart header=“Ultrashort function names” Functions that are used
      <em>very often</em> sometimes have ultrashort names.
    </p>
    <p>
      For example, the <a href="http://jquery.com">jQuery</a> framework defines
      a function with <code>$</code>. The
      <a href="http://lodash.com/">Lodash</a> library has its core function
      named <code>_</code>.
    </p>
    <p>
      These are exceptions. Generally function names should be concise and
      descriptive. ```
    </p>
    <h2 id="functions-comments">Functions == Comments</h2>
    <p>
      Functions should be short and do exactly one thing. If that thing is big,
      maybe it’s worth it to split the function into a few smaller functions.
      Sometimes following this rule may not be that easy, but it’s definitely a
      good thing.
    </p>
    <p>
      A separate function is not only easier to test and debug – its very
      existence is a great comment!
    </p>
    <p>
      For instance, compare the two functions <code>showPrimes(n)</code> below.
      Each one outputs
      <a href="https://en.wikipedia.org/wiki/Prime_number">prime numbers</a> up
      to <code>n</code>.
    </p>
    <p>The first variant uses a label:</p>
    <div class="sourceCode" id="cb10">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb10-1" title="1"><span class="kw">function</span> <span class="at">showPrimes</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-2" title="2">  <span class="dt">nextPrime</span><span class="op">:</span> <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">2</span><span class="op">;</span> i <span class="op">&lt;</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-3" title="3">    <span class="cf">for</span> (<span class="kw">let</span> j <span class="op">=</span> <span class="dv">2</span><span class="op">;</span> j <span class="op">&lt;</span> i<span class="op">;</span> j<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb10-4" title="4">      <span class="cf">if</span> (i <span class="op">%</span> j <span class="op">==</span> <span class="dv">0</span>) <span class="cf">continue</span> nextPrime<span class="op">;</span></a>
<a class="sourceLine" id="cb10-5" title="5">    <span class="op">}</span></a>
<a class="sourceLine" id="cb10-6" title="6"></a>
<a class="sourceLine" id="cb10-7" title="7">    <span class="at">alert</span>(i)<span class="op">;</span> <span class="co">// a prime</span></a>
<a class="sourceLine" id="cb10-8" title="8">  <span class="op">}</span></a>
<a class="sourceLine" id="cb10-9" title="9"><span class="op">}</span></a></code></pre>
    </div>
    <p>
      The second variant uses an additional function <code>isPrime(n)</code> to
      test for primality:
    </p>
    <div class="sourceCode" id="cb11">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb11-1" title="1"><span class="kw">function</span> <span class="at">showPrimes</span>(n) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-2" title="2"></a>
<a class="sourceLine" id="cb11-3" title="3">  <span class="cf">for</span> (<span class="kw">let</span> i <span class="op">=</span> <span class="dv">2</span><span class="op">;</span> i <span class="op">&lt;</span> n<span class="op">;</span> i<span class="op">++</span>) <span class="op">{</span></a>
<a class="sourceLine" id="cb11-4" title="4">    <span class="op">*!*</span><span class="cf">if</span> (<span class="op">!</span><span class="at">isPrime</span>(i)) <span class="cf">continue</span><span class="op">;*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb11-5" title="5"></a>
<a class="sourceLine" id="cb11-6" title="6"><span class="ss">    alert</span><span class="sc">(</span><span class="ss">i</span><span class="sc">)</span><span class="ss">;  // a prime</span></a>
<a class="sourceLine" id="cb11-7" title="7"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb11-8" title="8"><span class="ss">}</span></a>
<a class="sourceLine" id="cb11-9" title="9"></a>
<a class="sourceLine" id="cb11-10" title="10"><span class="ss">function isPrime</span><span class="sc">(</span><span class="ss">n</span><span class="sc">)</span><span class="ss"> {</span></a>
<a class="sourceLine" id="cb11-11" title="11"><span class="ss">  for </span><span class="sc">(</span><span class="ss">let i = 2; i &lt; n; i</span><span class="sc">++)</span><span class="ss"> {</span></a>
<a class="sourceLine" id="cb11-12" title="12"><span class="ss">    if </span><span class="sc">(</span><span class="ss"> n % i == 0</span><span class="sc">)</span><span class="ss"> return false;</span></a>
<a class="sourceLine" id="cb11-13" title="13"><span class="ss">  }</span></a>
<a class="sourceLine" id="cb11-14" title="14"><span class="ss">  return true;</span></a>
<a class="sourceLine" id="cb11-15" title="15"><span class="ss">}</span></a></code></pre>
    </div>
    <p>
      The second variant is easier to understand, isn’t it? Instead of the code
      piece we see a name of the action (<code>isPrime</code>). Sometimes people
      refer to such code as <em>self-describing</em>.
    </p>
    <p>
      So, functions can be created even if we don’t intend to reuse them. They
      structure the code and make it readable.
    </p>
    <h2 id="summary">Summary</h2>
    <p>A function declaration looks like this:</p>
    <div class="sourceCode" id="cb12">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb12-1" title="1"><span class="kw">function</span> <span class="at">name</span>(parameters<span class="op">,</span> delimited<span class="op">,</span> by<span class="op">,</span> comma) <span class="op">{</span></a>
<a class="sourceLine" id="cb12-2" title="2">  <span class="co">/* code */</span></a>
<a class="sourceLine" id="cb12-3" title="3"><span class="op">}</span></a></code></pre>
    </div>
    <ul>
      <li>
        Values passed to a function as parameters are copied to its local
        variables.
      </li>
      <li>
        A function may access outer variables. But it works only from inside
        out. The code outside of the function doesn’t see its local variables.
      </li>
      <li>
        A function can return a value. If it doesn’t, then its result is
        <code>undefined</code>.
      </li>
    </ul>
    <p>
      To make the code clean and easy to understand, it’s recommended to use
      mainly local variables and parameters in the function, not outer
      variables.
    </p>
    <p>
      It is always easier to understand a function which gets parameters, works
      with them and returns a result than a function which gets no parameters,
      but modifies outer variables as a side-effect.
    </p>
    <p>Function naming:</p>
    <ul>
      <li>
        A name should clearly describe what the function does. When we see a
        function call in the code, a good name instantly gives us an
        understanding what it does and returns.
      </li>
      <li>A function is an action, so function names are usually verbal.</li>
      <li>
        There exist many well-known function prefixes like <code>create…</code>,
        <code>show…</code>, <code>get…</code>, <code>check…</code> and so on.
        Use them to hint what a function does.
      </li>
    </ul>
    <p>
      Functions are the main building blocks of scripts. Now we’ve covered the
      basics, so we actually can start creating and using them. But that’s only
      the beginning of the path. We are going to return to them many times,
      going more deeply into their advanced features.
    </p>
  </body>
</html>
